#include <stdio.h>
#include <stdlib.h>
#include <math.h>
 
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLTEXIMAGE3DPROC glTexImage3D;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

#include "trackball.h"
#include "Noise3.h"

/* ̂̐F */
GLfloat sphereColor[] = { 1.0, 1.0, 1.0, 1.0 };
GLfloat dodecaColor[] = { 1.0, 1.0, 1.0, 1.0 };
GLfloat clipColor[] = { 1.0, 1.0, 1.0, 1.0 };

/* ̈ʒu */
GLfloat pos[] = { 3.0, 2.0, 5.0, 1.0 };

/* _̈ʒu */
GLdouble ex = 3.0, ey = 4.0, ez = 5.0;

/* ڕW_̈ʒu */
GLdouble tx = 0.0, ty = 0.0, tz = 0.0;

/* Nbv */
GLdouble clip[] = { 0.0, 0.0, -1.0, 0.0 };

/* \}`̃fBXvCXgԍ */
GLuint sphere, dodeca, plane;

/*
** eNX`
*/
#define TEXWIDTH  64                        /* eNX`̕@@@ */
#define TEXHEIGHT 64                        /* eNX`̍@@ */
#define TEXDEPTH  64                        /* eNX`̉s@ */
static double genfunc[][4] = {    /* eNX`֐̃p[^ */
  { 1.0, 0.0, 0.0, 0.0 },
  { 0.0, 1.0, 0.0, 0.0 },
  { 0.0, 0.0, 1.0, 0.0 },
};

/*
** eNX`̃p^[w肷
*/
#define CHECKER    0
#define NOISE      1
#define PERLIN     2
#define TURBULENCE 3
#define PATTERN    TURBULENCE

void display(void)
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

  /* fr[ϊs̏ */
  glLoadIdentity();

  /* _̈ړ */
  gluLookAt(ex, ey, ez, tx, ty, tz, 0.0, 1.0, 0.0);

  /* ̈ʒuݒ */
  glLightfv(GL_LIGHT0, GL_POSITION, pos);

  /* Nbvʂ̐ݒ */
  glPushMatrix();
  glMultMatrixd(trackballRotation());
  glClipPlane(GL_CLIP_PLANE0, clip);
  glPopMatrix();

  /* eNX`}bsOJn */
  glEnable(GL_TEXTURE_3D);
  
  /* eNX`W̎Lɂ */
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);

  /* XeVobt@̎gpJn */
  glEnable(GL_STENCIL_TEST);

  /* XeVobt@֏ނ悤ɐݒ */
  glStencilFunc(GL_ALWAYS, 0x0, 0xffffffff);

  /* NbvÔPQʑ̂Ɠ̋` */
  glEnable(GL_CLIP_PLANE0);
  glCallList(dodeca);
  glCallList(sphere);
  glDisable(GL_CLIP_PLANE0);

  /* XeVQƂĕ`悷悤ɐݒ */
  glStencilFunc(GL_NOTEQUAL, 0x0, 0xffffffff);

  /* LbvNbvʂƓlɉ]ĕ` */
  glPushMatrix();
  glLoadIdentity();
  gluLookAt(ex, ey, ez, tx, ty, tz, 0.0, 1.0, 0.0);
  glMultMatrixd(trackballRotation());
  glMatrixMode(GL_TEXTURE);
  glLoadMatrixd(trackballRotation());
  glMatrixMode(GL_MODELVIEW);
  glCallList(plane);
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();

  /* XeVobt@̎gpI */
  glDisable(GL_STENCIL_TEST);

  /* eNX`W̎𖳌ɂ */
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  
  /* eNX`}bsOI */
  glDisable(GL_TEXTURE_3D);
  
  glutSwapBuffers();
}

void resize(int w, int h)
{
  /* gbN{[͈ */
  trackballRegion(w, h);

  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);

  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);

  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(30.0, (double)w / (double)h, 1.0, 100.0);

  /* fr[ϊs̎w */
  glMatrixMode(GL_MODELVIEW);
}

void idle(void)
{
  glutPostRedisplay();
}

void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* Aj[VJn */
      glutIdleFunc(idle);
      /* gbN{[Jn */
      trackballStart(x, y);
      break;
    case GLUT_UP:
      /* Aj[VI */
      glutIdleFunc(0);
      /* gbN{[I */
      trackballStop(x, y);
      break;
    default:
      break;
    }
    break;
  default:
    break;
  }
}

void motion(int x, int y)
{
  trackballMotion(x, y);
}

void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case '\033':
    /* ESC ^CvI */
    exit(0);
  case 'x':
    ex += 0.5;
    break;
  case 'X':
    ex -= 0.5;
    break;
  case 'y':
    ey += 0.5;
    break;
  case 'Y':
    ey -= 0.5;
    break;
  case 'z':
    ez += 0.5;
    break;
  case 'Z':
    ez -= 0.5;
    break;
  default:
    break;
  }
  glutPostRedisplay();
}

void init(void)
{
  static GLubyte texture[TEXWIDTH][TEXHEIGHT][TEXDEPTH][4];
  Noise3 noise(5, 5, 5);

#if defined(WIN32)
  glTexImage3D =
    (PFNGLTEXIMAGE3DPROC)wglGetProcAddress("glTexImage3D");
#endif

  /* mCY֐găeNX` */
  for (int k = 0; k < TEXDEPTH; ++k) {
    double p = (double)k / (double)TEXDEPTH;
    for (int j = 0; j < TEXHEIGHT; ++j) {
      double q = (double)j / (double)TEXHEIGHT;
      for (int i = 0; i < TEXWIDTH; ++i) {
        double r = (double)i / (double)TEXWIDTH;
#if PATTERN == CHECKER
        if ((i >> 4) + (j >> 4) + (k >> 4) & 1)
          texture[k][j][i][0] = texture[k][j][i][1] = texture[k][j][i][2] = 255;
        else {
          texture[k][j][i][0] = 255;
          texture[k][j][i][1] = texture[k][j][i][2] = 0;
        }
#else
        texture[k][j][i][0] = texture[k][j][i][1] = texture[k][j][i][2] =
#  if PATTERN == NOISE
	  (GLubyte)(noise.noise(p, q, r) * 127.5 + 127.5);
#  elif PATTERN == PERLIN
          (GLubyte)(noise.perlin(p, q, r, 4, 0.5) * 127.5 + 127.5);
#  elif PATTERN == TURBULENCE
          (GLubyte)(noise.turbulence(p, q, r, 4, 0.5) * 127.5 + 127.5);
#  endif
#endif
        texture[k][j][i][3] = 255;
      }
    }
  }

  /* eNX`摜̓[hPʂɋlߍ܂Ă */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
  
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

  /* _̃IuWFNgԂɂWleNX`WɎg */
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
  
  /* eNX`W֐̐ݒ */
  glTexGendv(GL_S, GL_OBJECT_PLANE, genfunc[0]);
  glTexGendv(GL_T, GL_OBJECT_PLANE, genfunc[1]);
  glTexGendv(GL_R, GL_OBJECT_PLANE, genfunc[2]);

  /* eNX`̌JԂ̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_R, GL_REPEAT);

  /* eNX` */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

  /* eNX`̊蓖 */
  glTexImage3D(GL_TEXTURE_3D, 0, GL_RGBA, TEXWIDTH, TEXHEIGHT, TEXDEPTH, 0,
    GL_RGBA, GL_UNSIGNED_BYTE, texture);
    
  /* XeVobt@ɏނтɃXeVobt@̃rbg𔽓] */
  glStencilOp(GL_INVERT, GL_INVERT, GL_INVERT);

  /* }`u́vi glCullFace() gȂj
     Af̃XeVobt@ւ̏݉񐔂͋
     ȂBƂ낪ANbvĕ̂ɌJĂ܂ƁA
     ̕i̖͗ʂjɑ΂鏑
     񐔂͊ɂȂBāAXeVobt@̏
     ݂sxɃXeVobt@̃rbg𔽓]
     ΁A񏑂݂sꂽAȂ킿̕
     f̃XeVobt@lZbg邱ƂɂȂB*/

  /* ݒ */
  glClearColor(1.0, 1.0, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);

  /* gbN{[̏ */
  trackballInit();
}

void scene(void)
{
  /* \}`fBXvCXgɓo^ */
  int l = glGenLists(3);

  /* ̋ */
  sphere = l;
  glNewList(sphere, GL_COMPILE);
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, sphereColor);
  glutSolidSphere(1.0, 32, 16);
  glEndList();

  /* ÔPQʑ */
  dodeca = l + 1;
  glNewList(dodeca, GL_COMPILE);
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, dodecaColor);
  glutSolidDodecahedron();
  glEndList();

  /* Nbvꂽ̃Lbv */
  plane = l + 2;
  glNewList(plane, GL_COMPILE);
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, clipColor);
  glNormal3d(0.0, 0.0, 1.0);
  glBegin(GL_QUADS);
  glVertex3d(2.0, 2.0, 0.0);
  glVertex3d(-2.0, 2.0, 0.0);
  glVertex3d(-2.0, -2.0, 0.0);
  glVertex3d(2.0, -2.0, 0.0);
  glEnd();
  glEndList();
}

int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH | GLUT_STENCIL);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  scene();
  glutMainLoop();
  return 0;
}
